@use "sass:math";

@mixin prep-selector($sel: "::before") {
  position: relative;
  overflow: clip;
  &#{$sel} {
    content: "";
    position: absolute;
    box-sizing: border-box;
    width: 100%;
    height: 100%;
    top: 0;
    left: 0;
  }
}

@mixin mk-std-background($src, $sel: "::before") {
  @include prep-selector($sel);
  &#{$sel} {
    background: no-repeat center/contain url($src);
    filter: saturate(0%) brightness(130%);
  }
}

@mixin error {
  @include mk-std-background("./assets/plain/error.svg");

  &::before { filter: unset; }
}
@mixin warning {
  @include mk-std-background("./assets/plain/warning.svg");
}
@mixin info {
  @include mk-std-background("./assets/plain/info.svg");
}
@mixin loading($thickness: "0.5em") {
  @include prep-selector;
  &::before {
    aspect-ratio: 1 / 1;
    box-sizing: border-box;
    border: #{$thickness} solid var(--border-secondary-color);
    border-top-color: var(--border-accent-color);
    border-radius: 50%;
    animation: spin 2s linear infinite;

    filter: saturate(0%) brightness(130%);

    @keyframes spin {
      0% {transform: rotate(0deg);}
      100% {transform: rotate(360deg);}
    }
  }
}

// based off of https://www.clairecodes.com/blog/2018-10-10-css-polka-dot-background/
@mixin polka-dots($color, $spacing: 0.5em, $ratio: 0.3, $ratio-fade: $ratio, $stagger: true) {
  @include prep-selector;
  &::before {
    @if $stagger {
      background-image:
        radial-gradient($color 100% * $ratio, transparent 100% * $ratio-fade),
        radial-gradient($color 100% * $ratio, transparent 100% * $ratio-fade);
      background-position: 0 0, math.div($spacing, 2) math.div($spacing, 2);
    } @else {
      background-image: radial-gradient($color 100% * $ratio, transparent 100% * $ratio-fade);
    }
    background-size: $spacing $spacing;
    background-repeat: space;
  }

}

@mixin close {
  @include mk-std-background("./assets/plain/close.svg");
}

@mixin delete {
  @include mk-std-background("./assets/plain/delete.svg");
}

@mixin arrow-up {
  @include mk-std-background("./assets/plain/arrow.svg");
}


@mixin arrow-next {
  @include mk-std-background("./assets/plain/indicator-up.svg");
  &::before {transform: scaleX(-1) rotate(-90deg);}
}
@mixin arrow-prev {
  @include mk-std-background("./assets/plain/indicator-up.svg");
  &::before {transform: rotate(-90deg);}
}

@mixin indicator-up {
  @include mk-std-background("./assets/plain/indicator-up.svg");
}
@mixin indicator-left {
  @include indicator-up;
  &::before { transform: rotate(90deg); }
}
@mixin indicator-down {
  @include indicator-up;
  &::before { transform: rotate(180deg); }
}
@mixin indicator-up-down {
  @include mk-std-background("./assets/plain/indicator-up-down.svg");
}

@mixin new {
  @include mk-std-background("./assets/plain/plus.svg");
}

@mixin search {
  @include mk-std-background("./assets/plain/search.svg");
}

